using System;
using System.Text;
//using org.bouncycastle.math;
//using org.bouncycastle.math.ec;
//using org.bouncycastle.security;
using org.bouncycastle.crypto;
//using org.bouncycastle.crypto.signers;
using org.bouncycastle.crypto.digests;
using org.bouncycastle.crypto.engines;
using org.bouncycastle.crypto.encodings;
//using org.bouncycastle.crypto.generators;
using org.bouncycastle.crypto.parameters;
//using org.bouncycastle.crypto.macs;
//using org.bouncycastle.crypto.modes;
//using org.bouncycastle.crypto.paddings;
using org.bouncycastle.util.encoders;
using org.bouncycastle.util.test;

namespace test.crypto
{
	public class IDEATest: CipherTest
	{
		static Test[] tests =
		{
			new BlockCipherVectorTest(0, new IDEAEngine(),
					new KeyParameter(Hex.decode("00112233445566778899AABBCCDDEEFF")),
					"000102030405060708090a0b0c0d0e0f", "ed732271a7b39f475b4b2b6719f194bf"),
			new BlockCipherVectorTest(0, new IDEAEngine(),
					new KeyParameter(Hex.decode("00112233445566778899AABBCCDDEEFF")),
					"f0f1f2f3f4f5f6f7f8f9fafbfcfdfeff", "b8bc6ed5c899265d2bcfad1fc6d4287d")
		};

		IDEATest(): base(tests) {}

		public override String getName()
		{
			return "IDEA";
		}

		[STAThread]
		static void Main(string[] args)
		{
			IDEATest    test = new IDEATest();
			TestResult      result = test.perform();

			Console.WriteLine(result.ToString());
		}
	}


}
