using System;
using System.IO;
using System.Collections;
//using org.bouncycastle.io;

namespace org.bouncycastle.asn1
{
	/**
	* We insert one of these when we find a tag we don't recognise.
	*/
	public class DERUnknownTag: DERObject
	{
		int         tag;
		byte[]      data;

		/**
		* @param tag the tag value.
		* @param data the octets making up the time.
		*/
		public DERUnknownTag(
			int     tag,
			byte[]  data)
		{
			this.tag = tag;
			this.data = data;
		}

		public int getTag()
		{
			return tag;
		}

		public byte[] getData()
		{
			return data;
		}
		public override void encode(DEROutputStream  outStream)
			//throws IOException
		{
			outStream.writeEncoded(tag, data);
		}
	    
		public override bool Equals(
			Object  o)
		{
			if ((o == null) || !(typeof(DERUnknownTag).IsInstanceOfType(o)))
			{
				return false;
			}
	        
			DERUnknownTag other = (DERUnknownTag)o;
	        
			if(tag != other.tag)
			{
				return false;
			}
			
			if(data.Length != other.data.Length)
			{
				return false;
			}
			
			for(int i = 0; i < data.Length; i++) 
			{
				if(data[i] != other.data[i])
				{
					return false;
				}
			}
			
			return true;
		}
		public override int GetHashCode()
		{
			return base.GetHashCode();
		}

	}

}