
using System;
//using System.Collections;
using org.bouncycastle.math;
using org.bouncycastle.math.ec;
using org.bouncycastle.asn1;

namespace org.bouncycastle.asn1.x9
{
	/**
	* class for describing an ECPoint as a DER object.
	*/
	public class X9ECPoint: DEREncodable
	{
		ECPoint p;

		public X9ECPoint(
			ECPoint p)
		{
			this.p = p;
		}

		public X9ECPoint(
			ECCurve          c,
			ASN1OctetString  s)
		{
			this.p = c.decodePoint(s.getOctets());
		}

		public ECPoint getPoint()
		{
			return p;
		}

		/**
		* <pre>
		*  ECPoint ::= OCTET STRING
		* </pre>
		* <p>
		* Octet string produced using ECPoint.getEncoded().
		*/
		public DERObject getDERObject()
		{
			return new DEROctetString(p.getEncoded());
		}
	}


}