
using System;
using System.IO;
using org.bouncycastle.io;
using org.bouncycastle.crypto;

namespace org.bouncycastle.crypto.io
{
	public class DigestInputStream : FilterInputStream
	{
		protected Digest digest;

		public DigestInputStream(
			Stream stream,
			Digest      digest) : base(stream)
		{
			this.digest = digest;
		}

		public override   int read()
			//throws IOException
		{
			int b = inStream.ReadByte();

			if (b >= 0)
			{
				digest.update((byte)b);
			}
			return b;
		}

		public override  int read(
			byte[] b,
			int off,
			int len)
			//throws IOException
		{
			int n = inStream.Read(b, off, len);
			if (n > 0)
			{
				digest.update(b, off, n);
			}
			return n;
		}

		public Digest getDigest()
		{
			return digest;
		}
	}

}