
using System;
using System.IO;
using org.bouncycastle.io;
using org.bouncycastle.crypto;

namespace org.bouncycastle.crypto.io
{
	public class MacInputStream : FilterInputStream
	{
		protected Mac mac;

		public MacInputStream(
			Stream stream,
			Mac         mac) : base(stream)
		{
			this.mac = mac;
		}

		public override  int read()
			//throws IOException
		{
			int b = inStream.ReadByte();

			if (b >= 0)
			{
				mac.update((byte)b);
			}
			return b;
		}

		public override int read(
			byte[] b,
			int off,
			int len)
			//throws IOException
		{
			int n = inStream.Read(b, off, len);
			if (n >= 0)
			{
				mac.update(b, off, n);
			}
			return n;
		}

		public Mac getMac()
		{
			return mac;
		}
	}

}