
using System;
using System.IO;

namespace org.bouncycastle.io
{
	public class FilterOutputStream : Stream 
	{
		protected Stream outStream;
		  
		protected FilterOutputStream(Stream underlying) {
			outStream = underlying;
		}

		public override int ReadByte() //throws IOException 
		{
			throw new NotSupportedException();
		}
		  
		public override int Read(byte[] b, int offset, int length) //throws IOException 
		{
			throw new NotSupportedException();
		}

		public override void Write(
			byte[] buffer,
			int offset,
			int count)
		{
			outStream.Write(buffer, offset, count);
		}

		public override void WriteByte(byte val)
		{
			outStream.WriteByte(val);
		}


		public override bool CanRead 
		{
			get { return false; 	}
		}

		public override bool CanWrite 
		{
			get { return true; 	}
		}

		public override bool CanSeek 
		{
			get { return outStream.CanSeek; 	}
		}

		public override long Length 
		{
			get { return outStream.Length; 	}
		}

		public override long Position 
		{
			get { return outStream.Position;   }
			set { outStream.Position = value;  }
		}

		public override void Close() //throws IOException 
		{
			outStream.Close();
		}

		public override  void Flush()
		{
			outStream.Flush();
		}

		public override long Seek(
			long offset,
			SeekOrigin origin)
		{
			return outStream.Seek(offset,origin);
		}

		public override void SetLength(long val)
		{
			outStream.SetLength(val);
		}





		public virtual void write(int b) //throws IOException 
		{
			outStream.WriteByte((byte)(b));
		}
		  
		public virtual void write(byte[] b) //throws IOException 
		{
			write(b, 0, b.Length);
		}
		  
		public virtual void write(byte[] b, int offset, int length) //throws IOException 
		{
			for (int i = 0; i < length; i++) {
				WriteByte(b[offset + i]);
			}
		}
		  
		public virtual void flush() //throws IOException 
		{
			outStream.Flush();
		}
		  
		public virtual void close() //throws IOException 
		{
			outStream.Close();
		}
	}
}